--Territory v1.0b
--by Jon Irons; concept by Gregory Smith
--thanks also to Darren Watts
--Two teams (red and blue) fight for control of
--a map's polygons. Score is based on the
--average percentage (over the game's length)
--of a player's controlled floor area.

CollectionsUsed = {17, 18, 99}


Triggers = {}

function Triggers.init()
   first = true
   team_score = {}
   team_score["red"] = 0
   team_score["blue"] = 0
   timer = 0
   map_area = 0
   sums = {}
   sums.red = 0
   sums.blue = 0
   textures = {}
   textures.red = {}
   textures.red.index = 7
   textures.red.collection = 18
   textures.blue = {}
   textures.blue.index = 26
   textures.blue.collection = 17
   for pl in Players() do
      if pl.team ~= "red" then
	 pl.team = "blue"
      end
      pl._area = 0
      pl._percentage = 0
      pl._score = 0
      pl._revive = 0
   end

   for po in Polygons() do
      po._owner = "neutral"
      po._original = {}
      po._original.floor = {}
      po._original.floor.texture = po.floor.texture_index
      po._original.floor.collection = po.floor.collection
      po._original.ceiling = {}
      po._original.ceiling.texture = po.ceiling.texture_index
      po._original.ceiling.collection = po.ceiling.collection
      map_area = map_area + po.area
   end
end

function Triggers.idle()
   if Game.type ~= "netscript" then
      if first then
	 Players.print("You need to gather this with"..
		    "the Netscript game type.")
	 first = false
      end
      return
   end
   timer = timer + 1
   for pl in Players() do pl._area = 0 end

   for po in Polygons() do
      local owner
      local neutral = false
      for mo in po:monsters() do
	 if mo.player and not mo.player.dead and
	    (mo.z == mo.polygon.floor.z or
	     mo.player.head_below_media)
	 then
	    owner = mo.player
	    neutral = false
	 end
	 for mo2 in po:monsters() do
	    if mo ~= mo2 and mo.player and mo2.player then
	       if mo.player.team ~= mo2.player.team then
		  neutral = true
	       end
	    end
	 end
      end
      if not neutral then
	 if owner and po._owner ~= owner then
	    change_polygon_owner_to(po, owner)
	 end
      else
	 if po._owner ~= "neutral" then neutralize_polygon(po) end
      end
      if po._owner ~= "neutral" then
	 po._owner._area = po._owner._area + po.area
      end
   end

   local team_percentage = {}
   team_percentage["red"], team_percentage["blue"] = 0,0

   for pl in Players() do
      local team = pl.team.mnemonic
      pl._percentage = pl._area/map_area
      team_percentage[team] = team_percentage[team] + pl._percentage
      pl._score = pl._score + pl._percentage
      team_score[team] = team_score[team] + pl._percentage
      pl.points = pl._score/timer * 100
   end
   for pl in Players() do
      local team = pl.team.mnemonic
      pl.overlays[0]:fill_icon("red")
      pl.overlays[0].color = "white"
      pl.overlays[0].text =
	 math.floor(team_percentage["red"] * 100).."% ("..math.floor(team_score["red"]/timer * 100).."%)"
      pl.overlays[1]:fill_icon("blue")
      pl.overlays[1].color = "white"
      pl.overlays[1].text =
	 math.floor(team_percentage["blue"] * 100).."% ("..math.floor(team_score["blue"]/timer * 100).."%)"
      pl.overlays[2].icon = nil
      pl.overlays[2].color = "white"
      pl.overlays[2].text = "You: "..
	 math.floor(pl._percentage * 100).."% ("..math.floor(pl._score/timer * 100).."%)"
   end
end

function change_polygon_owner_to(poly, player)
   poly._owner = player
   poly.floor.collection = textures[player.team.mnemonic].collection
   poly.floor.texture_index = textures[player.team.mnemonic].index
   poly.ceiling.collection = textures[player.team.mnemonic].collection
   poly.ceiling.texture_index = textures[player.team.mnemonic].index
end

function neutralize_polygon(poly)
   poly._owner = "neutral"
   poly.floor.collection = poly._original.floor.collection
   poly.floor.texture_index = poly._original.floor.texture
   poly.ceiling.collection = poly._original.ceiling.collection
   poly.ceiling.texture_index = poly._original.ceiling.texture
end

function padded_seconds(time)
   local seconds = pad(math.floor(time/30))
   local ticks = pad(math.mod(time, 30))
   return seconds..":"..ticks
end

function pad(num)
   if num < 10 then return "0"..num end
   return num
end
